#include "Options.h"
#include <CommCtrl.h>

COptions::COptions(void)
{
    this->bReadRoleSystem = FALSE;
    this->bEnabled = TRUE;
    *this->VoiceName = 0;
    this->PoolingMouseTime = COption_READ_MOUSE_LOOP_TEMPO;
    this->PoolingWindowTime = COPTION_READ_WINDOW_LOOP_TEMPO;
    this->bUseHotKeys = FALSE;
    this->bAutoReadClipBoardContent = TRUE;
    this->ReadClipboardHotKey = MAKEWORD(VK_F11,HOTKEYF_CONTROL);
    this->StartStopHotKey = MAKEWORD(VK_F12,HOTKEYF_CONTROL);
    this->SwitchMouseWindowModeHotKey = MAKEWORD(VK_F10,HOTKEYF_CONTROL);
    this->VoiceSpeed=0;
    this->VoiceVolume=100;

    CStdFileOperations::GetAppPath(this->FileName,MAX_PATH);
    _tcscat(this->FileName,COption_FILENAME);
    this->pIniFile=new CIniFile(this->FileName);
    this->pIniFile->SetCurrentSectionName(_T("ScreenReader"));
}

COptions::~COptions(void)
{
    delete this->pIniFile;
}

BOOL COptions::LoadVoiceSpeedAndVolume()
{
    if (!CStdFileOperations::DoesFileExists(this->FileName))
        return FALSE;

    BOOL bRet = TRUE;
    BOOL bCurrentRet;

    TCHAR VoiceConfigSection[COption_VOICE_NAME_MAX_LEN+_countof(COption_VOICE_SECTION_PREFIX)];
    _tcscpy(VoiceConfigSection,COption_VOICE_SECTION_PREFIX);
    _tcscat(VoiceConfigSection,this->VoiceName);
    //TCHAR* Tmp=VoiceConfigSection;
    //while (Tmp)
    //{
    //    Tmp = _tcspbrk(Tmp,_T(" '"));
    //    if (Tmp)
    //        *Tmp = '_';
    //}
    // set current section
    this->pIniFile->SetCurrentSectionName(VoiceConfigSection);

    bCurrentRet = this->pIniFile->Get(COption_VOICE_SPEED,0,&this->VoiceSpeed);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_VOICE_VOLUME,100,&this->VoiceVolume);
    bRet = bRet && bCurrentRet;

    // restore default section
    this->pIniFile->SetCurrentSectionName(_T("ScreenReader"));

    return bRet;
}
BOOL COptions::SaveVoiceSpeedAndVolume()
{
    TCHAR VoiceConfigSection[COption_VOICE_NAME_MAX_LEN+_countof(COption_VOICE_SECTION_PREFIX)];
    _tcscpy(VoiceConfigSection,COption_VOICE_SECTION_PREFIX);
    _tcscat(VoiceConfigSection,this->VoiceName);

    // set current section
    this->pIniFile->SetCurrentSectionName(VoiceConfigSection);

    BOOL bRet = TRUE;
    BOOL bCurrentRet;
    
    bCurrentRet = this->pIniFile->Set(COption_VOICE_SPEED,this->VoiceSpeed);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_VOICE_VOLUME,this->VoiceVolume);
    bRet = bRet && bCurrentRet;

    // restore default section
    this->pIniFile->SetCurrentSectionName(_T("ScreenReader"));

    return bRet;
}

BOOL COptions::Load()
{
    if (!CStdFileOperations::DoesFileExists(this->FileName))
        return FALSE;

    BOOL bRet = TRUE;
    BOOL bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_ENABLED,1,(DWORD*)&this->bEnabled);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_READ_ROLE_SYSTEM,1,(DWORD*)&this->bReadRoleSystem);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_VOICE_NAME,L"",this->VoiceName,COption_VOICE_NAME_MAX_LEN);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_READ_TEMPO,COption_READ_MOUSE_LOOP_TEMPO,&this->PoolingMouseTime);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_READ_WINDOW_TEMPO,COPTION_READ_WINDOW_LOOP_TEMPO,&this->PoolingWindowTime);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_USE_HOTKEYS,0,(DWORD*)&this->bUseHotKeys);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_AUTO_READ_CLIPBOARD,1,(DWORD*)&this->bAutoReadClipBoardContent);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_READ_CLIPBOARD_HOTKEY,MAKEWORD(VK_F11,HOTKEYF_CONTROL),&this->ReadClipboardHotKey);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_START_STOP_HOTKEY,MAKEWORD(VK_F12,HOTKEYF_CONTROL),&this->StartStopHotKey);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Get(COption_MOUSE_TO_WINDOW_MODE_HOTKEY,MAKEWORD(VK_F10,HOTKEYF_CONTROL),&this->SwitchMouseWindowModeHotKey);
    bRet = bRet && bCurrentRet;
    
    // must be loaded after voice name
    bCurrentRet = this->LoadVoiceSpeedAndVolume();
    bRet = bRet && bCurrentRet;

    return bRet;
}
BOOL COptions::Save()
{
    BOOL bRet = TRUE;
    BOOL bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_ENABLED,this->bEnabled);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_READ_ROLE_SYSTEM,this->bReadRoleSystem);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_VOICE_NAME,this->VoiceName);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_READ_TEMPO,this->PoolingMouseTime);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_READ_WINDOW_TEMPO,this->PoolingWindowTime);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_USE_HOTKEYS,this->bUseHotKeys);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_AUTO_READ_CLIPBOARD,this->bAutoReadClipBoardContent);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_READ_CLIPBOARD_HOTKEY,this->ReadClipboardHotKey);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_START_STOP_HOTKEY,this->StartStopHotKey);
    bRet = bRet && bCurrentRet;
    bCurrentRet = this->pIniFile->Set(COption_MOUSE_TO_WINDOW_MODE_HOTKEY,this->SwitchMouseWindowModeHotKey);
    bRet = bRet && bCurrentRet;
    
    bCurrentRet = this->SaveVoiceSpeedAndVolume();
    bRet = bRet && bCurrentRet;

    return bRet;
}