#pragma once

#include <Windows.h>
#include "../Tools/Ini/IniFile.h"

#define COption_READ_MOUSE_LOOP_TEMPO               500
#define COPTION_READ_WINDOW_LOOP_TEMPO              250
#define COption_VOICE_NAME_MAX_LEN                  1024
#define COption_FILENAME                            L"ScreenReader.ini"

#define COption_ENABLED                             L"Enabled"
#define COption_READ_ROLE_SYSTEM                    L"ReadRoleSystem"
#define COption_VOICE_NAME                          L"VoiceName"
#define COption_READ_TEMPO                          L"ReadLoopTempo"
#define COption_READ_WINDOW_TEMPO                   L"ReadLoopTempoOnSameWindow"
#define COption_USE_HOTKEYS                         L"UseHotKeys"
#define COption_READ_CLIPBOARD_HOTKEY               L"ReadClipboardHotKey"
#define COption_START_STOP_HOTKEY                   L"StartStopHotKey"
#define COption_AUTO_READ_CLIPBOARD                 L"AutoReadClipboardOnChange"
#define COption_MOUSE_TO_WINDOW_MODE_HOTKEY         L"SwitchMouseWindowMode"

#define COption_VOICE_SECTION_PREFIX                L"CFG_"
#define COption_VOICE_SPEED                         L"Speed"
#define COption_VOICE_VOLUME                        L"Volume"

class COptions
{
private:
    TCHAR FileName[MAX_PATH];
    CIniFile* pIniFile;
public:
    DWORD PoolingMouseTime;
    DWORD PoolingWindowTime;
    BOOL bReadRoleSystem;
    BOOL bEnabled;
    WCHAR VoiceName[COption_VOICE_NAME_MAX_LEN];
    BOOL bUseHotKeys;
    BOOL bAutoReadClipBoardContent;
    DWORD ReadClipboardHotKey;
    DWORD StartStopHotKey;
    DWORD SwitchMouseWindowModeHotKey;

    DWORD VoiceSpeed;
    DWORD VoiceVolume;
    COptions(void);
    ~COptions(void);

    BOOL Load();
    BOOL Save();

    BOOL LoadVoiceSpeedAndVolume();
    BOOL SaveVoiceSpeedAndVolume();
};
