#include "ReadUI.h"

CReadUI::CReadUI(void)
{
}

CReadUI::~CReadUI(void)
{
}

//-----------------------------------------------------------------------------
// Name: Show
// Object: show the filter dialog box
// Parameters :
//     in  : HINSTANCE hInstance : application instance
//           HWND hWndDialog : main window dialog handle
//     out :
//     return : 
//-----------------------------------------------------------------------------
INT_PTR CReadUI::Show(HINSTANCE hInstance,HWND hWndDialog,CVoice* pVoice)
{
    INT_PTR Ret;
    CReadUI* pReadUI=new CReadUI();
    pReadUI->pVoice=pVoice;

    Ret=pReadUI->CDialogBase::Show(hInstance,hWndDialog,IDD_DIALOG_READ,IDI_ICON_READ);
    delete pReadUI;
    return Ret;
}

void CReadUI::OnCancel()
{
    this->pVoice->StopReading();
}
void CReadUI::OnOk()
{
    INT TextLen;
    WCHAR* Text;
    HWND hWnd = ::GetDlgItem(this->hWndDialog,IDC_EDIT_RAW_READ);
    TextLen = ::GetWindowTextLengthW(hWnd);
    if (TextLen <= 0)
        return;
    Text = new WCHAR[TextLen+1];
    ::GetWindowTextW(hWnd ,Text,TextLen);
    this->pVoice->Read(Text,TRUE);
    delete Text;
}

void CReadUI::OnCommand(WPARAM wParam,LPARAM lParam)
{
    UNREFERENCED_PARAMETER(lParam);
    switch (LOWORD(wParam))
    {
        case IDOK:
            this->OnOk();
            break;
        case IDCANCEL:
            this->OnCancel();
            break;
    }
}