#include "SelectWindowUI.h"


CSelectWindowUI::CSelectWindowUI(void)
{
    this->hWndSelectedWindow = NULL;

    this->SelectWindow.bSelectOnlyDialog=FALSE;
    this->SelectWindow.bOwnerWindowSelectable=FALSE;
    this->SelectWindow.bMinimizeOwnerWindowWhenSelect=TRUE;
}


CSelectWindowUI::~CSelectWindowUI(void)
{
}

//-----------------------------------------------------------------------------
// Name: Show
// Object: show the filter dialog box
// Parameters :
//     in  : HINSTANCE hInstance : application instance
//           HWND hWndDialog : main window dialog handle
//     out :
//     return : 
//-----------------------------------------------------------------------------
INT_PTR CSelectWindowUI::Show(HINSTANCE hInstance,HWND hWndDialog,OUT HWND* phWindow)
{
    INT_PTR Ret;
    CSelectWindowUI* pDialogUI=new CSelectWindowUI();
    Ret=pDialogUI->CDialogBase::Show(hInstance,hWndDialog,IDD_DIALOG_SELECT_WINDOW,IDI_ICON_SCREEN_READER);
    *phWindow = pDialogUI->hWndSelectedWindow;
    delete pDialogUI;
    return Ret;
}

void CSelectWindowUI::OnInit()
{
    this->SelectWindow.Initialize(this->hInstance,this->hWndDialog,IDC_STATIC_PICTURE_SELECT_TARGET,IDB_BLANK,IDB_CROSS,IDC_CURSOR_TARGET);
}

void CSelectWindowUI::OnCancel()
{
    this->hWndSelectedWindow = NULL;
    this->Close(IDCANCEL);
}
void CSelectWindowUI::OnOk()
{
    this->hWndSelectedWindow = this->SelectWindow.WindowHandle;
    this->Close(IDOK);
}

void CSelectWindowUI::OnCommand(WPARAM wParam,LPARAM lParam)
{
    UNREFERENCED_PARAMETER(lParam);
    switch (LOWORD(wParam))
    {
    case IDOK:
        this->OnOk();
        break;
    case IDCANCEL:
        this->OnCancel();
        break;
    }
}

//-----------------------------------------------------------------------------
// Name: OnMouseDown
// Object: WM_MOUSEDOWN callback
// Parameters :
//     in  : LPARAM lParam : Dialog callback LPARAM
//     out :
//     return : 
//-----------------------------------------------------------------------------
void CSelectWindowUI::OnMouseDown(WPARAM wParam,LPARAM lParam)
{
    UNREFERENCED_PARAMETER(wParam);
    this->SelectWindow.MouseDown(lParam);
}
//-----------------------------------------------------------------------------
// Name: OnMouseUp
// Object: WM_MOUSEUP callback
// Parameters :
//     in  : LPARAM lParam : Dialog callback LPARAM
//     out :
//     return : 
//-----------------------------------------------------------------------------
void CSelectWindowUI::OnMouseUp(WPARAM wParam,LPARAM lParam)
{
    UNREFERENCED_PARAMETER(wParam);
    UNREFERENCED_PARAMETER(lParam);

    this->SelectWindow.MouseUp();
}

//-----------------------------------------------------------------------------
// Name: OnMouseMove
// Object: WM_MOUSEMOVE callback
// Parameters :
//     in  : LPARAM lParam : Dialog callback LPARAM
//     out :
//     return : 
//-----------------------------------------------------------------------------
void CSelectWindowUI::OnMouseMove(WPARAM wParam,LPARAM lParam)
{
    UNREFERENCED_PARAMETER(wParam);
    BOOL bWindowChanged=FALSE;
    this->SelectWindow.MouseMove(lParam,&bWindowChanged);
    //if (bWindowChanged)
    //{
    //    TCHAR Str[128];
    //    _sntprintf(Str,_countof(Str),_T("0x%08X"),this->SelectWindow.WindowHandle);
    //    this->SetDlgItemText(IDC_EDIT_HWND,Str);
    //}
}